diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/iw/partition_gui.py anaconda-storage/iw/partition_gui.py
--- anaconda/iw/partition_gui.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/iw/partition_gui.py	2009-02-17 12:02:31.000000000 -0600
@@ -372,8 +372,8 @@
 #              (N_("Size (MB)"), gobject.TYPE_STRING, 1.0, 0, isLeaf),
               (N_("Format"), gobject.TYPE_OBJECT, 0.5, 0, isFormattable),
               (N_("Size (MB)"), gobject.TYPE_STRING, 1.0, 0, 0),
-              (N_("Start"), gobject.TYPE_STRING, 1.0, 0, 1),
-              (N_("End"), gobject.TYPE_STRING, 1.0, 0, 1),
+#              (N_("Start"), gobject.TYPE_STRING, 1.0, 0, 1),
+#              (N_("End"), gobject.TYPE_STRING, 1.0, 0, 1),
 	      ("", gobject.TYPE_STRING, 0.0, 0, 0),
               # the following must be the last two
               ("IsLeaf", gobject.TYPE_BOOLEAN, 0.0, 1, 0),
@@ -632,8 +632,7 @@
         return rc
         
     def getNext(self):
-        (errors, warnings) = self.partitions.sanityCheckAllRequests(self.diskset)
-
+        (errors, warnings) = self.storage.sanityCheckAllRequests()
         if errors:
             labelstr1 =  _("The partitioning scheme you requested "
                            "caused the following critical errors.")
@@ -649,6 +648,7 @@
             raise gui.StayOnScreen
         
         if warnings:
+            # "storage configuration"
             labelstr1 = _("The partitioning scheme you requested "
                           "generated the following warnings.")
             labelstr2 = _("Would you like to continue with "
@@ -663,8 +663,7 @@
             if rc != 1:
                 raise gui.StayOnScreen
 
-        formatWarnings = getPreExistFormatWarnings(self.partitions,
-                                                   self.diskset)
+        formatWarnings = getPreExistFormatWarnings(self.storage)
         if formatWarnings:
             labelstr1 = _("The following pre-existing partitions have been "
                           "selected to be formatted, destroying all data.")
@@ -676,7 +675,7 @@
             commentstr = ""
             for (dev, type, mntpt) in formatWarnings:
                 commentstr = commentstr + \
-                        "/dev/%s         %s         %s\n" % (dev,type,mntpt)
+                        "%s         %s         %s\n" % (dev,type,mntpt)
 
             rc = self.presentPartitioningComments(_("Format Warnings"),
                                                   labelstr1, labelstr2,
@@ -695,161 +694,153 @@
 
     def getPrev(self):
         self.diskStripeGraph.shutDown()
-        self.diskset.refreshDevices()
-        self.partitions.setFromDisk(self.diskset)
+        self.storage.reset()
         self.tree.clear()
         del self.parent
         return None
 
-    def getShortFSTypeName(self, name):
-	if name == "physical volume (LVM)":
-	    return "LVM PV"
-
-	return name
-    
     def populate(self, initial = 0):
-
-        drives = self.diskset.disks.keys()
-        drives.sort()
-
         self.tree.resetSelection()
 
 	self.tree.clearHiddenPartitionsList()
 
 	# first do LVM
-        lvmrequests = self.partitions.getLVMRequests()
-        if lvmrequests:
+        vgs = self.storage.vgs
+        if vgs:
 	    lvmparent = self.tree.append(None)
 	    self.tree[lvmparent]['Device'] = _("LVM Volume Groups")
-            for vgname in lvmrequests.keys():
-		vgrequest = self.partitions.getRequestByVolumeGroupName(vgname)
-		rsize = vgrequest.getActualSize(self.partitions, self.diskset)
+            for vg in vgs:
+		rsize = vg.size
 
                 vgparent = self.tree.append(lvmparent)
-		self.tree[vgparent]['Device'] = "%s" % (vgname,)
-                if vgrequest and vgrequest.type != REQUEST_NEW and vgrequest.fslabel:
-                    self.tree[vgparent]['Label'] = "%s" % (vgrequest.fslabel,)
-                else:
-                    self.tree[vgparent]['Label'] = ""
+		self.tree[vgparent]['Device'] = "%s" % vg.name
+                self.tree[vgparent]['Label'] = ""
 		self.tree[vgparent]['Mount Point'] = ""
-		self.tree[vgparent]['Start'] = ""
-		self.tree[vgparent]['End'] = ""
+		#self.tree[vgparent]['Start'] = ""
+		#self.tree[vgparent]['End'] = ""
 		self.tree[vgparent]['Size (MB)'] = "%Ld" % (rsize,)
-                self.tree[vgparent]['PyObject'] = str(vgrequest.uniqueID)
-		for lvrequest in lvmrequests[vgname]:
+                #self.tree[vgparent]['PyObject'] = str(vgrequest.uniqueID)
+		for lv in vg.lvs:
 		    iter = self.tree.append(vgparent)
-		    self.tree[iter]['Device'] = lvrequest.logicalVolumeName
-		    if lvrequest.fstype and lvrequest.mountpoint:
-			self.tree[iter]['Mount Point'] = lvrequest.mountpoint
+		    self.tree[iter]['Device'] = lv.lvname
+		    if lv.format.mountable and lv.format.mountpoint:
+			self.tree[iter]['Mount Point'] = lv.format.mountpoint
 		    else:
 			self.tree[iter]['Mount Point'] = ""
-		    self.tree[iter]['Size (MB)'] = "%Ld" % (lvrequest.getActualSize(self.partitions, self.diskset, True),)
+		    self.tree[iter]['Size (MB)'] = "%Ld" % lv.size
+                    # FIXME: need something to store as unique id
 		    self.tree[iter]['PyObject'] = str(lvrequest.uniqueID)
 		
-                    ptype = lvrequest.fstype.getName()
-                    if lvrequest.isEncrypted(self.partitions, True) and lvrequest.format:
+                    if lv.format == "luks" and not lv.format.exists:
 			self.tree[iter]['Format'] = self.lock_pixbuf
-                    elif lvrequest.format:
+                    elif not lv.format.exists:
 			self.tree[iter]['Format'] = self.checkmark_pixbuf
-                    self.tree[iter]['IsFormattable'] = lvrequest.fstype.isFormattable()
+                    self.tree[iter]['IsFormattable'] = lv.format.formattable
 		    self.tree[iter]['IsLeaf'] = True
-		    self.tree[iter]['Type'] = ptype
-		    self.tree[iter]['Start'] = ""
-		    self.tree[iter]['End'] = ""
+                    # FIXME: DevicFormat needs an attr to store a pretty
+                    #        type name
+		    self.tree[iter]['Type'] = lv.format.type
+		    #self.tree[iter]['Start'] = ""
+		    #self.tree[iter]['End'] = ""
 
         # handle RAID next
-        raidrequests = self.partitions.getRaidRequests()
-        if raidrequests:
+        mdarrays = self.storage.mdarrays
+        if mdarrays:
 	    raidparent = self.tree.append(None)
 	    self.tree[raidparent]['Device'] = _("RAID Devices")
-            for request in raidrequests:
+            for array in mdarrays:
 		mntpt = None
-		if request and request.fstype and request.fstype.getName() == "physical volume (LVM)":
-		    vgreq = self.partitions.getLVMVolumeGroupMemberParent(request)
-		    if vgreq and vgreq.volumeGroupName:
-			if self.show_uneditable:
-			    mntpt = vgreq.volumeGroupName
-			else:
-			    self.tree.appendToHiddenPartitionsList(str(request.uniqueID))
-			    continue
+                if array.format.type == "lvmpv":
+                    vg = None
+		    for _vg in self.storage.vgs:
+                        if _vg.dependsOn(array):
+                            vg = _vg
+                            break
+                    if vg and self.show_uneditable:
+                        mntpt = vg.name
+                    elif vg:
+                        self.tree.appendToHiddenPartitionsList(str(request.uniqueID))
+                        continue
 		    else:
 			mntpt = ""
+                elif array.format.mountable and array.format.mountpoint:
+                    mntpt = array.format.mountpoint
 
                 iter = self.tree.append(raidparent)
 		if mntpt:
                     self.tree[iter]["Mount Point"] = mntpt
+                else:
+                    self.tree[iter]["Mount Point"] = ""
 		    
-                if request and request.mountpoint:
-                    self.tree[iter]["Mount Point"] = request.mountpoint
-		    
-                if request.fstype:
-                    ptype = self.getShortFSTypeName(request.fstype.getName())
-
-                    if request.isEncrypted(self.partitions, True) and request.format:
+                if array.format.type != "none":
+                    ptype = array.format.type
+                    if ptype == "luks" and not array.format.exists:
 			self.tree[iter]['Format'] = self.lock_pixbuf
-                    elif request.format:
+                    elif not array.format.exists:
                         self.tree[iter]['Format'] = self.checkmark_pixbuf
-                    self.tree[iter]['IsFormattable'] = request.fstype.isFormattable()
+                    self.tree[iter]['IsFormattable'] = array.format.formattable
                 else:
                     ptype = _("None")
                     self.tree[iter]['IsFormattable'] = False
 
-		try:
-		    device = "/dev/md%d" % (request.raidminor,)
-		except:
+		if array.minor is not None:
+		    device = "%s" % array.path
+		else:
 		    device = "Auto"
 		    
                 self.tree[iter]['IsLeaf'] = True
                 self.tree[iter]['Device'] = device
-                if request and request.type != REQUEST_NEW and request.fslabel:
-                    self.tree[iter]['Label'] = "%s" % (request.fslabel,)
+                if array.format.exists and getattr(array.format, "label", None):
+                    self.tree[iter]['Label'] = "%s" % array.format.label
                 else:
                     self.tree[iter]['Label'] = ""
                 self.tree[iter]['Type'] = ptype
-                self.tree[iter]['Start'] = ""
-                self.tree[iter]['End'] = ""
-                self.tree[iter]['Size (MB)'] = "%Ld" % (request.getActualSize(self.partitions, self.diskset),)
+                #self.tree[iter]['Start'] = ""
+                #self.tree[iter]['End'] = ""
+                self.tree[iter]['Size (MB)'] = "%Ld" % array.size
                 self.tree[iter]['PyObject'] = str(request.uniqueID)
 
 	# now normal partitions
+        disks = self.storage.disks
 	drvparent = self.tree.append(None)
 	self.tree[drvparent]['Device'] = _("Hard Drives")
-        for drive in drives:
-            disk = self.diskset.disks[drive]
-
+        for disk in disks:
             # add a disk stripe to the graph
-            stripe = self.diskStripeGraph.add(drive, disk)
+            stripe = self.diskStripeGraph.add(disk.name, disk.partedDisk)
 
             # add a parent node to the tree
             parent = self.tree.append(drvparent)
-            self.tree[parent]['Device'] = '/dev/%s' % (drive,)
-            self.tree[parent]['PyObject'] = str('/dev/%s' % (drive,))
-            (cylinders, heads, sectors) = disk.device.biosGeometry
+            self.tree[parent]['Device'] = "%s" % disk.path
+            self.tree[parent]['PyObject'] = "%s" % disk.path
+            (cylinders, heads, sectors) = disk.partedDisk.device.biosGeometry
             sectorsPerCyl = heads * sectors
 
-            extendedParent = None
-            part = disk.getFirstPartition()
+            part = disk.partedDisk.getFirstPartition()
             while part:
                 if part.type & parted.PARTITION_METADATA:
                     part = part.nextPartition()
                     continue
+
+                extendedParent = None
+                partName = part.getDeviceNodeName()
+                device = self.storage.devicetree.getDeviceByName(partName)
+                if not device:
+                    raise RuntimeError("can't find partition %s in device"
+                                       " tree" % partName)
+
                 # ignore the tiny < 1 MB partitions (#119479)
                 if part.getSize(unit="MB") <= 1.0:
-                    if not part.is_active() or not part.getFlag(parted.PARTITION_BOOT):
-                        part = part.nextPartition()
+                    if not part.active or not device.bootable:
                         continue
 
                 stripe.add(part)
-                device = part.getDeviceNodeName()
-                request = self.partitions.getRequestByDeviceName(device)
-
-                if part.type == parted.PARTITION_EXTENDED:
+                if device.isExtended:
                     if extendedParent:
                         raise RuntimeError, ("can't handle more than "
                                              "one extended partition per disk")
                     extendedParent = self.tree.append(parent)
                     iter = extendedParent
-                elif part.type & parted.PARTITION_LOGICAL:
+                elif device.isLogical:
                     if not extendedParent:
                         raise RuntimeError, ("crossed logical partition "
                                              "before extended")
@@ -859,16 +850,20 @@
                     iter = self.tree.append(parent)
                     self.tree[iter]['IsLeaf'] = True
 
-                if request and request.mountpoint:
-                    self.tree[iter]['Mount Point'] = request.mountpoint
+                if device.format.mountable and device.format.mountpoint:
+                    self.tree[iter]['Mount Point'] = device.format.mountpoint
                 else:
                     self.tree[iter]['Mount Point'] = ""
 
-		if request and request.fstype and request.fstype.getName() == "physical volume (LVM)":
-		    vgreq = self.partitions.getLVMVolumeGroupMemberParent(request)
-		    if vgreq and vgreq.volumeGroupName:
+		if device.format.type == "lvmpv":
+		    vg = None
+                    for _vg in self.storage.vgs:
+                        if _vg.dependsOn(part):
+                            vg = _vg
+                            break
+		    if vg and vg.name:
 			if self.show_uneditable:
-			    self.tree[iter]['Mount Point'] = vgreq.volumeGroupName
+			    self.tree[iter]['Mount Point'] = vg.name
 			else:
 			    self.tree.appendToHiddenPartitionsList(part)
 			    self.tree.remove(iter)
@@ -876,26 +871,31 @@
 		    else:
 			self.tree[iter]['Mount Point'] = ""
 
-                    if request.isEncrypted(self.partitions, True) and request.format:
+                    if device.format.type == "luks" and \
+                       not device.format.exists:
                         self.tree[iter]['Format'] = self.lock_pixbuf
-		    elif request.format:
+		    elif not device.format.exists:
 			self.tree[iter]['Format'] = self.checkmark_pixbuf
 		
-                if request and request.fstype:
-                    self.tree[iter]['IsFormattable'] = request.fstype.isFormattable()
+                if device.format.type != "none":
+                    self.tree[iter]['IsFormattable'] = device.format.formattable
 
-                if part.type & parted.PARTITION_FREESPACE:
-                    ptype = _("Free space")
-                elif part.type == parted.PARTITION_EXTENDED:
+                if device.isExtended:
                     ptype = _("Extended")
-                elif part.getFlag(parted.PARTITION_RAID) == 1:
+                elif device.format.type == "mdraid":
                     ptype = _("software RAID")
-		    parreq = self.partitions.getRaidMemberParent(request)
-		    if parreq:
+                    mds = self.storage.mdarrays
+                    array = None
+                    for _array in mds:
+                        if _array.dependsOn(device):
+                            array = _array
+                            break
+		    if array:
 			if self.show_uneditable:
-			    try:
-				mddevice = "/dev/md%d" % (parreq.raidminor,)
-			    except:
+                            if array.minor is not None:
+                                mddevice = "%s" % array.path
+                            else:
+                                mddevice = "Auto"
 				mddevice = "Auto"
 			    self.tree[iter]['Mount Point'] = mddevice
 			else:
@@ -906,41 +906,28 @@
 		    else:
 			self.tree[iter]['Mount Point'] = ""
 
-                    if request and request.isEncrypted(self.partitions, True) and request.format:
-			self.tree[iter]['Format'] = self.lock_pixbuf
-                elif part.fileSystem:
-                    if request and request.fstype != None:
-                        ptype = self.getShortFSTypeName(request.fstype.getName())
-                        if ptype == "foreign":
-                            ptype = map_foreign_to_fsname(part)
-                    else:
-                        ptype = part.fileSystem.type
-
-                    if request and request.isEncrypted(self.partitions, True) and request.format:
+                    if device.format.type == "luks" and \
+                       not device.format.exists:
 			self.tree[iter]['Format'] = self.lock_pixbuf
-                    elif request and request.format:
-			self.tree[iter]['Format'] = self.checkmark_pixbuf
                 else:
-                    if request and request.fstype != None:
-                        ptype = self.getShortFSTypeName(request.fstype.getName())
-
-                        if ptype == "foreign":
-                            ptype = map_foreign_to_fsname(part)
+                    if device.format.type != "none":
+                        ptype = device.format.type
                     else:
                         ptype = _("None")
                 if part.type & parted.PARTITION_FREESPACE:
                     devname = _("Free")
                 else:
-                    devname = '/dev/%s' % (device,)
+                    devname = "%s" % device.path
                 self.tree[iter]['Device'] = devname
-                if request and request.type != REQUEST_NEW and request.fslabel:
-                    self.tree[iter]['Label'] = "%s" % (request.fslabel,)
+                if device.format.exists and
+                   getattr(device.format, "label", None):
+                    self.tree[iter]['Label'] = "%s" % device.format.label
                 else:
                     self.tree[iter]['Label'] = ""
 
                 self.tree[iter]['Type'] = ptype
-                self.tree[iter]['Start'] = str(disk.device.startSectorToCylinder(part.geometry.start))
-                self.tree[iter]['End'] = str(disk.device.endSectorToCylinder(part.geometry.end))
+                #self.tree[iter]['Start'] = str(disk.device.startSectorToCylinder(part.geometry.start))
+                #self.tree[iter]['End'] = str(disk.device.endSectorToCylinder(part.geometry.end))
                 size = part.getSize(unit="MB")
                 if size < 1.0:
                     sizestr = "< 1"
@@ -968,20 +955,22 @@
             self.diskStripeGraph.selectSlice(partition)
 
     def newCB(self, widget):
-        request = NewPartitionSpec(fileSystemTypeGetDefault(), size = 200)
-
-        self.editPartitionRequest(request, isNew = 1)
+        device = self.storage.newPartition()
+        self.editPartition(device, isNew=1)
 
     def deleteCb(self, widget):
         curselection = self.tree.getCurrentPartition()
-
         if curselection:
-            if doDeletePartitionByRequest(self.intf, self.partitions, curselection):
+            if doDeletePartitionByRequest(self.intf,
+                                          self.storage,
+                                          curselection):
                 self.refresh()
         else:
             curdevice = self.tree.getCurrentDevice()
             if curdevice and len(curdevice) > 5:
-                if doDeletePartitionsByDevice(self.intf, self.partitions, self.diskset, curdevice[5:]):
+                if doDeletePartitionsByDevice(self.intf,
+                                              self.storage,
+                                              curdevice[5:]):
                     self.refresh()
                 else:
                     return
@@ -1000,25 +989,10 @@
         self.diskStripeGraph.shutDown()
         self.tree.clear()
 
-	# XXXX - Backup some info which doPartitioning munges if it fails
-	origInfoDict = {}
-	for request in self.partitions.requests:
-	    try:
-		origInfoDict[request.uniqueID] = (request.requestSize, request.currentDrive)
-	    except:
-		pass
-
         try:
-            autopart.doPartitioning(self.diskset, self.partitions)
+            autopart.doPartitioning(self.storage)
             rc = 0
         except PartitioningError, msg:
-	    try:
-		for request in self.partitions.requests:
-		    if request.uniqueID in origInfoDict.keys():
-			(request.requestSize, request.currentDrive) = origInfoDict[request.uniqueID]
-	    except:
-		log.error("Failed to restore original info")
-
             self.intf.messageWindow(_("Error Partitioning"),
                    _("Could not allocate requested partitions: %s.") % (msg),
 				    custom_icon="error")
@@ -1045,10 +1019,11 @@
                 rc = -1
             else:
                 rc = 0
-                reqs = self.partitions.getBootableRequest()
-                if reqs:
-                    for req in reqs:
-                        req.ignoreBootConstraints = 1
+                all_devices = self.storage.devicetree.devices.values()
+                bootDevs = [d for d in all_devices if d.bootable]
+                #if reqs:
+                #    for req in reqs:
+                #        req.ignoreBootConstraints = 1
 
 	if not rc == -1:
 	    self.populate()
@@ -1058,33 +1033,35 @@
     def editCb(self, *args):
         part = self.tree.getCurrentPartition()
 
-        (type, request) = doEditPartitionByRequest(self.intf, self.partitions,
-                                                   part)
-        if request:
+        (type, device) = doEditPartitionByRequest(self.intf,
+                                                  self.storage,
+                                                  part)
+        if device:
             if type == "RAID":
-                self.editRaidRequest(request)
+                self.editRaidArray(device)
 	    elif type == "LVMVG":
-		self.editLVMVolumeGroup(request)
+		self.editLVMVolumeGroup(device)
 	    elif type == "LVMLV":
-		vgrequest = self.partitions.getRequestByID(request.volumeGroup)
-		self.editLVMVolumeGroup(vgrequest)
+		self.editLVMVolumeGroup(device.vg)
             elif type == "NEW":
-		self.editPartitionRequest(request, isNew = 1)
+		self.editPartition(device, isNew = 1)
             else:
-                self.editPartitionRequest(request)
+                self.editPartition(device)
 
     # isNew implies that this request has never been successfully used before
-    def editRaidRequest(self, raidrequest, isNew = 0):
-	raideditor = raid_dialog_gui.RaidEditor(self.partitions,
-						     self.diskset, self.intf,
-						     self.parent, raidrequest,
-						     isNew)
-	origpartitions = self.partitions.copy()
+    def editRaidArray(self, raiddev, isNew = 0):
+	raideditor = raid_dialog_gui.RaidEditor(self.storage,
+						self.intf,
+						self.parent,
+                                                raiddev,
+						isNew)
+        # is a shallow copy enough?
+	origpartitions = self.storage.devicetree.copy()
 	
 	while 1:
-	    request = raideditor.run()
+	    device = raideditor.run()
 
-	    if request is None:
+	    if device is None:
 		return
 
 	    if not isNew:
@@ -1108,29 +1085,29 @@
 	raideditor.destroy()		
 
 
-    def editPartitionRequest(self, origrequest, isNew = 0, restrictfs = None):
+    def editPartition(self, origdevice, isNew = 0, restrictfs = None):
 	parteditor = partition_dialog_gui.PartitionEditor(self.anaconda,
 							  self.parent,
-							  origrequest,
+							  origdevice,
 							  isNew = isNew,
                                                           restrictfs = restrictfs)
 
 	while 1:
-	    request = parteditor.run()
+	    actions = parteditor.run()
 
-	    if request is None:
+	    if not actions:
 		return 0
 
-            if not isNew:
-                self.partitions.removeRequest(origrequest)
+            for action in actions:
+                # XXX we should handle exceptions here
+                self.anaconda.id.storage.devicetree.registerAction(action)
 
-            self.partitions.addRequest(request)
             if self.refresh():
-                # the add failed; remove what we just added and put
-                # back what was there if we removed it
-                self.partitions.removeRequest(request)
-                if not isNew:
-                    self.partitions.addRequest(origrequest)
+                # autopart failed -- cancel the actions and try to get
+                # back to previous state
+                actions.reverse()
+                for action in actions:
+                    self.anaconda.id.storage.devicetree.cancelAction(action)
                 if self.refresh():
                     # this worked before and doesn't now...
                     raise RuntimeError, ("Returning partitions to state "
